//---------------------------------------------------------------------------

#ifndef configH
#define configH
//---------------------------------------------------------------------------
#define SENS_ROUKANA 10
#define SENS_KANAROU 11
#define SENS_FRANROU 12
#define SENS_KANAFRAN 13

#define POLICE_CLAIR 20
#define POLICE_STYLE 21

#define MODE_LIBRE 30
#define MODE_EXAM 31
#define MODE_EXAM_CHRONO 32

#define ALPHA_HIRA 'H'
#define ALPHA_KATA 'K'
#define ALPHA_KANJI 'J'

#define DATA_CAR 50
#define DATA_MOT 51

#define NIV_FACILE 6
#define NIV_DIFFICILE 5

struct param
{
	bool ficFind;
	int alphabet, data, sens, nb_car_aff, nb_kanas_sel, nb_mots, nb_mots_type,
			police, mode, niv;
};
struct voc
{
	bool sel, rand;
	char type;
	AnsiString roumaji, tradFr, kana;
};
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include "uMain.h"
#include "table.h"
#include <ComCtrls.hpp>
//---------------------------------------------------------------------------
class Tfrm_config : public TForm
{
__published:	// Composants grs par l'EDI
	TBitBtn *BtnOk;
	TButton *BtnTable;
	TGroupBox *GpbAff;
	TLabel *LblAff;
	TEdit *EdAff;
	TGroupBox *GpbSens;
	TRadioButton *RdbRoukana;
	TRadioButton *RdbKanarou;
	TGroupBox *GpbAlphabets;
	TRadioButton *rbtnPoliceClair;
	TRadioButton *rbtnPoliceStyle;
	TGroupBox *GpbMode;
	TRadioButton *rbtnModeLibre;
	TRadioButton *rbtnModeExam;
	TRadioButton *rbtnModeExamChrono;
	TRadioButton *RdbHira;
	TRadioButton *RdbKata;
	TRadioButton *RdbKanji;
	TGroupBox *GpbVoc;
	TRadioButton *RbtnCar;
	TRadioButton *RbtnMot;
	TGroupBox *GroupBox1;
	TRadioButton *RbtnKanarouM;
	TRadioButton *RbtnFranrou;
	TRadioButton *RbtnKanafran;
	TGroupBox *GpbNiveau;
	TRadioButton *RdbFacile;
	TRadioButton *RdbDifficile;
	void __fastcall BtnOkClick(TObject *Sender);
	void __fastcall BtnTableClick(TObject *Sender);
	void __fastcall FormActivate(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall RdbRoukanaClick(TObject *Sender);
	void __fastcall RdbKanarouClick(TObject *Sender);
	void __fastcall RbtnCarClick(TObject *Sender);
	void __fastcall RbtnMotClick(TObject *Sender);
	void __fastcall rbtnModeExamChronoClick(TObject *Sender);
	void __fastcall rbtnModeExamClick(TObject *Sender);
	void __fastcall rbtnModeLibreClick(TObject *Sender);
private:	// Dclarations de l'utilisateur
	void AfficherAide( AnsiString message );
public:		// Dclarations de l'utilisateur
	struct param parametres;
	__fastcall Tfrm_config(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE Tfrm_config *frm_config;
//---------------------------------------------------------------------------
#endif
