//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#define ON "On"
#define OFF "Off"

#include "uMain.h"
#include "table.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
Tfrm_table *frm_table;
//---------------------------------------------------------------------------
__fastcall Tfrm_table::Tfrm_table(TComponent* Owner)
				: TForm(Owner)
{
}

//---------------------------------------------------------------------------
void Tfrm_table::VerifierTable()
{
	TCheckBox *checkBox;
	TButton *button;
	//rinitialiser les boutons
	BtnBloc1->Caption = ON;
	BtnBloc2->Caption = ON;
	BtnBloc3->Caption = ON;
	BtnBloc4->Caption = ON;
	BtnTout->Caption = ON;
	for( int i = 0; i < 16; i++ )
	{
		button = TrouverBouton( i+1, true );
		if( i != 10 )
			button->Caption = ON;
	}
	for( int j = 0; j < 8; j++ )
	{
		button = TrouverBouton( j+1, false );
		button->Caption = ON;
	}

	for( int i = 0; i < 16; i++ )
		for( int j = 0; j < 8; j++ )
		{
			checkBox = TrouverCase( i+1, j+1 );
			if( checkBox != NULL )
			{
				if( checkBox->Checked )
				{
					button = TrouverBouton( i+1, true );
					if( i != 10 )
						button->Caption = OFF;
					button = TrouverBouton( j+1, false );
					button->Caption = OFF;
					BtnTout->Caption = OFF;
					if( i >= 0 && i < 11 && j >= 0 && j < 5 ) BtnBloc1->Caption = OFF;
					if( i >= 0 && i < 9 && j >= 5 && j < 8 ) BtnBloc2->Caption = OFF;
					if( i >= 11 && i < 16 && j >= 0 && j < 5 ) BtnBloc3->Caption = OFF;
					if( i >= 11 && i < 16 && j >= 5 && j < 8 ) BtnBloc4->Caption = OFF;
				}
			}
		}

	btn_valid->SetFocus();
}
//---------------------------------------------------------------------------
TCheckBox *Tfrm_table::TrouverCase( int lgn, int col )
{
	TComponent *component;
	component = this->FindComponent( "cb" + IntToStr(lgn) + "_" + IntToStr(col) );
	if( component == NULL ) return NULL;
	if( !component->InheritsFrom(__classid(TCheckBox)) ) return NULL;

	return dynamic_cast<TCheckBox *>(component);
}

//---------------------------------------------------------------------------
TButton *Tfrm_table::TrouverBouton( int num, bool lgn )
{
	TComponent *component;
	AnsiString name;
	name.sprintf("btn_%s%d", (lgn) ? "lgn" : "col", num );
	component = this->FindComponent( name );
	if( component == NULL ) return NULL;
	if( !component->InheritsFrom(__classid(TButton)) ) return NULL;

	return dynamic_cast<TButton *>(component);
}


//---------------------------------------------------------------------------
void Tfrm_table::CocherLigne( int num )
{
	TCheckBox *checkBox;
	TButton *button = TrouverBouton( num, true );
	for( int j = 0; j < 8; j++ )
	{
		checkBox = TrouverCase( num, j+1 );
		if( checkBox != NULL )
			checkBox->Checked = (button->Caption == ON) ? true : false;
	}
	if( button != NULL )
		button->Caption = (button->Caption == ON) ? OFF : ON;
	VerifierTable();
}

//---------------------------------------------------------------------------
void Tfrm_table::CocherColonne( int num )
{
	TCheckBox *checkBox;
	TButton *button = TrouverBouton( num, false );
	for( int j = 0; j < 16; j++ )
	{
		checkBox = TrouverCase( j+1, num );
		if( checkBox != NULL )
			checkBox->Checked = (button->Caption == ON) ? true : false;
	}
	if( button != NULL )
		button->Caption = (button->Caption == ON) ? OFF : ON;
	VerifierTable();
}

//---------------------------------------------------------------------------
void __fastcall Tfrm_table::btn_lgn1Click(TObject *Sender){ CocherLigne(1); }
void __fastcall Tfrm_table::btn_lgn2Click(TObject *Sender){ CocherLigne(2); }
void __fastcall Tfrm_table::btn_lgn3Click(TObject *Sender){ CocherLigne(3); }
void __fastcall Tfrm_table::btn_lgn4Click(TObject *Sender){ CocherLigne(4); }
void __fastcall Tfrm_table::btn_lgn5Click(TObject *Sender){ CocherLigne(5); }
void __fastcall Tfrm_table::btn_lgn6Click(TObject *Sender){ CocherLigne(6); }
void __fastcall Tfrm_table::btn_lgn7Click(TObject *Sender){ CocherLigne(7); }
void __fastcall Tfrm_table::btn_lgn8Click(TObject *Sender){ CocherLigne(8); }
void __fastcall Tfrm_table::btn_lgn9Click(TObject *Sender){ CocherLigne(9); }
void __fastcall Tfrm_table::btn_lgn10Click(TObject *Sender){ CocherLigne(10); }
void __fastcall Tfrm_table::btn_lgn12Click(TObject *Sender){ CocherLigne(12); }
void __fastcall Tfrm_table::btn_lgn13Click(TObject *Sender){ CocherLigne(13); }
void __fastcall Tfrm_table::btn_lgn14Click(TObject *Sender){ CocherLigne(14); }
void __fastcall Tfrm_table::btn_lgn15Click(TObject *Sender){ CocherLigne(15); }
void __fastcall Tfrm_table::btn_lgn16Click(TObject *Sender){ CocherLigne(16); }

//---------------------------------------------------------------------------
void __fastcall Tfrm_table::btn_col1Click(TObject *Sender) { CocherColonne(1); }
void __fastcall Tfrm_table::btn_col2Click(TObject *Sender) { CocherColonne(2); }
void __fastcall Tfrm_table::btn_col3Click(TObject *Sender) { CocherColonne(3); }
void __fastcall Tfrm_table::btn_col4Click(TObject *Sender) { CocherColonne(4); }
void __fastcall Tfrm_table::btn_col5Click(TObject *Sender) { CocherColonne(5); }
void __fastcall Tfrm_table::btn_col6Click(TObject *Sender) { CocherColonne(6); }
void __fastcall Tfrm_table::btn_col7Click(TObject *Sender) { CocherColonne(7); }
void __fastcall Tfrm_table::btn_col8Click(TObject *Sender) { CocherColonne(8); }

//---------------------------------------------------------------------------

void __fastcall Tfrm_table::btn_validClick(TObject *Sender)
{
	TCheckBox *checkbox;
	for( int i = 0; i < 16; i++ )
		for( int j = 0; j < 8; j++ )
		{
			checkbox = TrouverCase( i+1, j+1 );
			if( checkbox != NULL )
				FrmMain->tab_kanas[ i ][ j ].sel = ( checkbox->Checked ) ? true : false;
		}
	Close();
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_table::FormClose(TObject *Sender,
      TCloseAction &Action)
{
	btn_validClick( Sender );
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_table::BtnBloc1Click(TObject *Sender)
{
	TCheckBox *checkBox;
	for( int i = 0; i < 11; i++ )
		for( int j = 0; j < 5; j++ )
		{
			checkBox = TrouverCase( i+1, j+1 );
			if( checkBox != NULL )
				checkBox->Checked = (BtnBloc1->Caption == ON) ? true : false;
		}

	VerifierTable();
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_table::BtnBloc2Click(TObject *Sender)
{
	TCheckBox *checkBox;
	for( int i = 0; i < 9; i++ )
		for( int j = 5; j < 8; j++ )
		{
			checkBox = TrouverCase( i+1, j+1 );
			if( checkBox != NULL )
				checkBox->Checked = (BtnBloc2->Caption == ON) ? true : false;
		}

	VerifierTable();
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_table::BtnBloc3Click(TObject *Sender)
{
	TCheckBox *checkBox;
	for( int i = 11; i < 16; i++ )
		for( int j = 0; j < 5; j++ )
		{
			checkBox = TrouverCase( i+1, j+1 );
			if( checkBox != NULL )
				checkBox->Checked = (BtnBloc3->Caption == ON) ? true : false;
		}

	VerifierTable();
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_table::BtnBloc4Click(TObject *Sender)
{
	TCheckBox *checkBox;
	for( int i = 11; i < 16; i++ )
		for( int j = 5; j < 8; j++ )
		{
			checkBox = TrouverCase( i+1, j+1 );
			if( checkBox != NULL )
				checkBox->Checked = (BtnBloc4->Caption == ON) ? true : false;
		}

	VerifierTable();
}
//---------------------------------------------------------------------------

void __fastcall Tfrm_table::BtnToutClick(TObject *Sender)
{
	TCheckBox *checkBox;
	for( int i = 0; i < 16; i++ )
		for( int j = 0; j < 8; j++ )
		{
			checkBox = TrouverCase( i+1, j+1 );
			if( checkBox != NULL )
				checkBox->Checked = (BtnTout->Caption == ON) ? true : false;
		}

	VerifierTable();
}

void __fastcall Tfrm_table::FormShow(TObject *Sender)
{
	TCheckBox *checkbox;
	for( int i = 0; i < 16; i++ )
		for( int j = 0; j < 8; j++ )
		{
			checkbox = TrouverCase( i+1, j+1 );
			if( checkbox != NULL )
				checkbox->Checked = ( FrmMain->tab_kanas[ i ][ j ].sel ) ? true : false;
		}

	VerifierTable();
}
//---------------------------------------------------------------------------

