//---------------------------------------------------------------------------

#ifndef uMainH
#define uMainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Menus.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include "config.h"
#include "results.h"
#include "divers.h"
//---------------------------------------------------------------------------
class TFrmMain : public TForm
{
__published:	// Composants grs par l'EDI
	TGroupBox *GpbAff;
	TGroupBox *GpbSaisie;
	TEdit *EdSaisie;
	TButton *BtnVerif;
	TRichEdit *LblAff;
	TButton *BtnLancer;
	TButton *BtnNext;
	TButton *BtnExit;
	TBitBtn *BtnConfig;
	TRichEdit *LblRep;
	TButton *BtnRep;
	TButton *BtnPrev;
	TTimer *TimExam;
	TLabel *LblInfo;
	TLabel *LblChrono;
	TLabel *LblScore;
	TGroupBox *GroupBox1;
	TLabel *Label1;
	TLabel *Label2;
	TLabel *Label3;
	TLabel *Label4;
	TLabel *Label5;
	TLabel *Label6;
	TLabel *LblAlphabet;
	TLabel *LblDonnees;
	TLabel *LblSens;
	TLabel *LblPolice;
	TLabel *LblNbCarAff;
	TLabel *LblCtrl;
	void __fastcall BtnExitClick(TObject *Sender);
	void __fastcall BtnLancerClick(TObject *Sender);
	void __fastcall BtnNextClick(TObject *Sender);
	void __fastcall BtnVerifClick(TObject *Sender);
	void __fastcall BtnConfigClick(TObject *Sender);
	void __fastcall BtnPrevClick(TObject *Sender);
	void __fastcall BtnRepClick(TObject *Sender);
	void __fastcall TimExamTimer(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
private:	// Dclarations de l'utilisateur
	void Initialiser();
	void ToutVider();
	AnsiString EstUnKana( AnsiString kana, int& nb );
	void SetDefault( TButton* bouton );
	AnsiString ConvertirRouKana( AnsiString roumaji, char type );

	struct param parametres;
	struct display
	{
		bool mot;
		int lgn, col;
	} *kana_choisis;
	int indice_kana, kana_courant, nb_correct, score, score_total, chrono;
public:		// Dclarations de l'utilisateur
	bool TrouverKana( AnsiString rou, int &i, int &j );
	bool TrouverRou( AnsiString kana, char alphabet, int &i, int &j );
	struct table
	{
		AnsiString roumaji, hiragana, katakana;
		bool sel, rand;
	} tab_kanas[16][8];
	struct voc *mots;
	int TEMPS_MAX, TEMPS_BEST;
	__fastcall TFrmMain(TComponent* Owner); //constructeur
};
//---------------------------------------------------------------------------
extern PACKAGE TFrmMain *FrmMain;
//---------------------------------------------------------------------------
#endif
